--- newrules.pl	2003-09-15 23:03:58.000000000 +0900
+++ /home/ynakam/newrules.pl	2003-10-11 15:46:07.000000000 +0900
@@ -17,13 +17,17 @@
 #    along with this program; if not, write to the Free Software
 #    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA     
 #                                        02111-1307  USA
+#    2003 Oct 11: Add -l option by Yuichi Nakamura(ynakam@users.sourceforge.jp)
 
 
+$load_policy_pattern="avc:.*granted.*{.*load_policy.*}";
+
 while ($opt = shift @ARGV) {
         if ($opt eq "-d") { $read_dmesg++; }
         elsif ($opt eq "-v") { $verbose++; }
         elsif ($opt eq "-i") { $input = shift @ARGV; }
         elsif ($opt eq "-o") { $output= shift @ARGV; }
+	elsif ($opt eq "-l") { $load_policy++; }
 	elsif ($opt eq "--help") { &printUsage; }
 		else  { print "unknown option, '$opt'\n\n"; &printUsage; }
 }
@@ -37,11 +41,23 @@
 elsif ($input)   { open (IN, "$input");      }
 else             { open (IN, "-");           }  # STDIN
 
-if ($output)     { open (OUT, ">$output");   }
+if ($output)     { open (OUT, ">>$output");   }
 else             { open (OUT, ">-");         }  # STDOUT
 
+if($load_policy){ #store logs after last "load_policy" in @log_buf
+    while ($line = <IN>) {
+	if($line=~/$load_policy_pattern/) {
+	     #stored logs are unnecessary
+	     undef @log_buf;
+	}
+	else
+	{
+	    push @log_buf,$line;
+	}
+    }
+}
 
-while ($line = <IN>) {
+while ($line=&readNewline) {
     next unless ($line =~ m/avc:\s*denied\s*\{((\w|\s)*)\}/);
     @types=split /\ /,$line;
     $info="";
@@ -121,11 +137,22 @@
 
 exit;
 
+sub readNewline {
+    if($load_policy){
+	$newline=shift @log_buf;
+    }else{
+	$newline=<IN>;
+    }
+    return $newline;
+}
+
 sub printUsage {
-	print "newrules [-d] [-v] [-i <inputfile> ] [-o <outputfile>]
+	print "newrules [-d] [-v] [-l] [-i <inputfile> ] [-o <outputfile>]
         -d      read input from output of /bin/dmesg
         -v      verbose output
+        -l      read input only after last \"load_policy\"
         -i      read input from <inputfile>
         -o      append output to <outputfile>\n";
 	exit;
 }
+
